<template>
  <v-layout align-center justify-center row wrap color="#f6f6f6">
    <v-dialog v-model="dialogLoader" persistent width="400">
      <v-card color="gray" dark>
        <v-card-text>
          Loading...
          <v-progress-linear
            indeterminate
            color="white"
            class="mb-0"
          ></v-progress-linear>
        </v-card-text>
      </v-card>
    </v-dialog>
    <v-flex xs12 pa-1>
      <v-layout>
        <v-flex xs12>
          <div class="font-size-24-bold" style="color:#6a7d69;">
            Upload Invoices
          </div>
        </v-flex>
      </v-layout>
      <div>
        <br />
        <v-form ref="formExcel" lazy-validation>
          <!-- Sheet Name -->
          <p
            style="border: 2px dashed grey; text-align:center; background-color:#F3F3F3;"
          >
            <v-icon color="#6a7d69" size="70px" style="padding: 24px;"
              >mdi-cloud-upload</v-icon
            ><br />
            <b>Upload Excel File</b>
            <v-layout
              align-center
              justify-start
              class="justify-center"
              style="margin: 10px 0 0 0;"
            >
              <v-flex xs4 v-if="!mobileView"
                ><a style="color:#cfb9b4;" href="/example_invoice.xlsx"
                  >Download Example File</a
                ></v-flex
              >
              <v-flex xs6 v-if="mobileView"
                ><a style="color:#cfb9b4;" href="/example_company.xlsx"
                  >Download Example File</a
                ></v-flex
              >
            </v-layout>
            <v-layout
              align-center
              justify-start
              class="justify-center"
              style="margin: 10px 0 0 0;"
            >
              <v-flex xs1 v-if="!mobileView"
                ><p class="font-size-16">
                  Sheet Name<span style="color: red;">&nbsp;*</span>
                </p></v-flex
              >
              <v-flex xs4 v-if="mobileView"
                ><p class="font-size-14">
                  Sheet Name<span style="color: red;">&nbsp;*</span>
                </p></v-flex
              >
              <v-flex xs4 pt-2 px-2 v-if="!mobileView">
                <!-- <v-text-field type="text" name="invoiceno" id="invoiceno" v-model="sheetName" color="black" solo single-line height="40"></v-text-field> -->
                <v-text-field
                  class="uploadField"
                  required
                  ref="sheetName"
                  label="Enter sheet name in Excel"
                  v-model="sheetName"
                  :rules="[() => !!sheetName || 'This field is required']"
                  color="black"
                  solo
                  single-line
                  height="40"
                  counter="30"
                  hint="master"
                >
                </v-text-field>
              </v-flex>
              <v-flex xs6 pt-2 px-2 v-if="mobileView">
                <v-text-field
                  class="uploadField"
                  required
                  ref="sheetName"
                  label="Enter sheet name in Excel"
                  v-model="sheetName"
                  :rules="[() => !!sheetName || 'This field is required']"
                  color="black"
                  solo
                  single-line
                  height="40"
                  counter="30"
                  hint="master"
                >
                </v-text-field>
              </v-flex>
            </v-layout>

            <!-- Select File -->
            <v-layout
              align-center
              justify-start
              class="justify-center"
              style="margin: 10px 0 0 0;"
            >
              <v-flex xs2 v-if="!mobileView"
                ><p class="font-size-16">
                  Select File<span style="color: red;">&nbsp;*</span>
                </p></v-flex
              >
              <v-flex xs4 v-if="mobileView"
                ><p class="font-size-14">
                  Select File<span style="color: red;">&nbsp;*</span>
                </p></v-flex
              >
              <v-flex
                xs4
                style="text-align:left; padding: 0px 0px 0px 0px;"
                v-if="!mobileView"
              >
                <v-chip class="black--text" v-show="fileName">
                  {{ fileName
                  }}<v-icon class="ml-3 cursor-pointer" @click="clearFile()"
                    >clear</v-icon
                  >
                </v-chip>
              </v-flex>
              <v-flex
                xs6
                style="text-align:left; padding: 0px 0px 0px 0px;"
                v-if="mobileView"
              >
                <v-chip class="black--text" v-show="fileName">
                  {{ fileName
                  }}<v-icon class="ml-3 cursor-pointer" @click="clearFile()"
                    >clear</v-icon
                  >
                </v-chip>
              </v-flex>
            </v-layout>

            <!-- Browse -->
            <v-layout
              align-center
              justify-start
              class="justify-center"
              style="margin: 10px 0 0 0;"
            >
              <input
                type="file"
                ref="fileExcel"
                style="display: none;"
                @change="setFileName()"
                accept="application/vnd.openxmlformats-officedocument.spreadsheetml.sheet"
              />
              <v-btn
                round
                color="#6a7d69"
                @click="$refs.fileExcel.click()"
                style="color:#efdbd4;"
                >Choose File&nbsp;&nbsp;&nbsp;
                <v-icon>mdi-file-find</v-icon>
              </v-btn>
            </v-layout>

            <!-- Submit -->
            <v-layout
              align-center
              justify-start
              class="justify-center"
              style="margin: 10px 0 24px 0;"
            >
              <!-- <v-btn v-if="!statusUpload" round color="#2a95bf" style="color:white;" @click="uploadFile()">&ensp;&emsp;&emsp;Submit&emsp;&emsp;&ensp;</v-btn> -->
              <v-btn
                outline
                depressed
                round
                style="color:#6a7d69;"
                @click="uploadFile()"
                >&ensp;&emsp;&emsp;Submit&emsp;&emsp;&ensp;</v-btn
              >
            </v-layout>
          </p>
        </v-form>
        <!-- <div v-if="showReview && formatType === 'master'" class="pt-4">
        <div class="font-size-24-bold">Review</div><br>
        <v-data-table
          :headers="headersMaster"
          :items="uploadData"
          class="elevation-1"
        >
          <template v-slot:items="props">
            <td class="text-xs-left">{{ props.item.invoice_no }}</td>
            <td class="text-xs-left">{{ props.item.invoice_date}}</td>
            <td class="text-xs-left">{{ props.item.start_date }}</td>
            <td class="text-xs-left">{{ props.item.due_date }}</td>
            <td class="text-xs-left">{{ props.item.customer_id }}</td>
            <td class="text-xs-left">{{ props.item.customer_name }}</td>
            <td class="text-xs-left">{{ props.item.customer_taxid }}</td>
            <td class="text-xs-right">{{ decimalfixed(props.item.amount)}}</td>
            <td class="text-xs-right">{{ decimalfixed(props.item.vat_amount) }}</td>
            <td class="text-xs-right">{{ decimalfixed(props.item.total_amount) }}</td>
            <td class="text-xs-right">{{ props.item.wht_rate}}</td>
            <td class="text-xs-right">{{ decimalfixed(props.item.wht_amount) }}</td>
            <td class="text-xs-right">{{ decimalfixed(props.item.pay_amount) }}</td>
            <td v-if="props.item.action_description && props.item.action_description !== 'skip' && props.item.action_description !== 'overwrite'" class="text-xs-center" style="color:#F44336;">
              <strong>{{ props.item.action_description }}</strong><br>
              <v-btn v-if="props.item.action_description === 'Duplicate Invoice No. in Excel file, Please check your input data.' || props.item.action_description === 'Duplicate Invoice No.' || props.item.action_description === 'This invoice has been paid'"
                     round outline depressed @click="skip(props.item.no)" style="color:#9E9E9E;">Skip</v-btn>
              <v-btn v-if="props.item.action_description === 'Duplicate Invoice No.'" round @click="overwrite(props.item.no)" color="#9E9E9E" style="color:white;">Replace</v-btn>
            </td>
            <td v-else class="text-xs-center"><strong>{{ props.item.action_description }}</strong></td>
          </template>
        </v-data-table>
        <v-layout align-center justify-start class="justify-center" style="margin: 20px 0 24px 0;">
          <v-btn outline depressed @click="clearFile()" style="color:#9E9E9E;">Cancel</v-btn>
          <v-btn v-if=" statusUpload === 'confirm' || statusUpload === 'wait confirm' " color="#6a7d69" style="color:white;" @click="confirm()">Confirm</v-btn>
        </v-layout>
      </div>
      <div v-else-if="showReview && formatType === 'detail'" class="pt-4">
        <div class="font-size-24-bold">Review</div><br>
        <v-data-table
          :headers="headersDetail"
          :items="uploadData"
          class="elevation-1"
        >
          <template v-slot:items="props">
            <td class="text-xs-left">{{ props.item.invoice_no }}</td>
            <td class="text-xs-left">{{ props.item.item_description}}</td>
            <td class="text-xs-right">{{ decimalfixed(props.item.item_unit_amount) }}</td>
            <td class="text-xs-right">{{ props.item.item_quantity }}</td>
            <td class="text-xs-right">{{ decimalfixed(props.item.item_amount) }}</td>
            <td v-if="props.item.action_description && props.item.action_description !== 'skip' && props.item.action_description !== 'overwrite'" class="text-xs-center" style="color:#F44336;">
              <strong>{{ props.item.action_description }}</strong><br>
              <v-btn v-if="props.item.action_description === 'Duplicate Invoice No. in Excel file, Please check your input data.' || props.item.action_description === 'Duplicate Invoice No.'"
                     round outline depressed @click="skip(props.item.no)" style="color:#9E9E9E;">Skip</v-btn>
              <v-btn v-if="props.item.action_description === 'Duplicate Invoice No.'" round @click="overwrite(props.item.no)" color="#9E9E9E" style="color:white;">Replace</v-btn>
            </td>
            <td v-else class="text-xs-center"><strong>{{ props.item.action_description }}</strong></td>
          </template>
        </v-data-table>
        <v-layout align-center justify-start class="justify-center" style="margin: 20px 0 24px 0;">
          <v-btn outline depressed @click="clearFile()" style="color:#9E9E9E;">Cancel</v-btn>
          <v-btn v-if=" statusUpload === 'confirm' || statusUpload === 'wait confirm' " color="#6a7d69" style="color:white;" @click="confirm()">Confirm</v-btn>
        </v-layout>
      </div> -->
      </div>
    </v-flex>
  </v-layout>
</template>

<script>
import { sync } from "vuex-pathify";
import moment from "moment";
import Swal from "sweetalert2";
moment.locale("en");
export default {
  data() {
    return {
      mobileView: false,
      sheetName: "Sheet1",
      fileName: "",
      isFile: false,
      userName: this.$cookies.get("username"),
      dialogLoader: false,
      showReview: false,
      headersMaster: [
        {
          text: "Invoice No",
          align: "left",
          sortable: false,
          value: "invoice_no"
        },
        {
          text: "Invoice Date",
          align: "left",
          sortable: false,
          value: "invoice_date"
        },
        {
          text: "Start Date",
          align: "left",
          sortable: false,
          value: "start_date"
        },
        { text: "Doc Date", align: "left", sortable: false, value: "due_date" },
        {
          text: "Customer Id",
          align: "left",
          sortable: false,
          value: "customer_id"
        },
        {
          text: "Customer Name",
          align: "left",
          sortable: false,
          value: "customer_name"
        },
        {
          text: "Customer Tax ID",
          align: "left",
          sortable: false,
          value: "customer_taxid"
        },
        { text: "Amount", align: "right", sortable: false, value: "amount" },
        {
          text: "VAT",
          align: "right",
          sortable: false,
          value: "vat_amount"
        },
        {
          text: "Total Amount",
          align: "right",
          sortable: false,
          value: "total_amount"
        },
        {
          text: "WHT Rate",
          align: "right",
          sortable: false,
          value: "wht_rate"
        },
        {
          text: "WHT",
          align: "right",
          sortable: false,
          value: "wht_amount"
        },
        {
          text: "Pay Amount",
          align: "right",
          sortable: false,
          value: "pay_amount"
        },
        {
          text: "Action Description",
          align: "center",
          sortable: false,
          value: "action_description"
        }
      ],
      headersDetail: [
        {
          text: "Invoice No",
          align: "left",
          sortable: false,
          value: "invoice_no"
        },
        {
          text: "Item Description",
          align: "left",
          sortable: false,
          value: "item_description"
        },
        {
          text: "Item Unit Amount",
          align: "right",
          sortable: false,
          value: "item_unit_amount"
        },
        {
          text: "Item Quantity",
          align: "right",
          sortable: false,
          value: "item_quantity"
        },
        {
          text: "Item Amount",
          align: "right",
          sortable: false,
          value: "item_amount"
        },
        {
          text: "Action Description",
          align: "center",
          sortable: false,
          value: "action_description"
        }
      ],
      uploadData: [],
      statusUpload: "",
      statusOldUpload: "",
      setInterval: "",
      formatType: ""
    };
  },
  methods: {
    addCommas(nStr) {
      nStr += "";
      var x = nStr.split(".");
      var x1 = x[0];
      var x2 = x.length > 1 ? "." + x[1] : "";
      var rgx = /(\d+)(\d{3})/;
      while (rgx.test(x1)) {
        x1 = x1.replace(rgx, "$1" + "," + "$2");
      }
      return x1 + x2;
    },
    decimalfixed(value) {
      let val = parseFloat(value).toFixed(2);
      return this.addCommas(val);
    },
    skip(index) {
      this.uploadData[index - 1].action_description = "skip";
    },
    overwrite(index) {
      this.uploadData[index - 1].action_description = "overwrite";
    },
    setFileName() {
      this.fileName = this.$refs.fileExcel.files[0].name;
      this.isFile = true;
    },
    clearFile() {
      // this.isFile = false
      // this.fileName = ''
      // this.$refs.formExcel.reset()
      location.reload();
    },
    checkUploadFile() {
      // console.log('checkUploadFile');
      let validate = true;
      for (let i = 0; i < this.uploadData.length; i++) {
        if (
          this.uploadData[i].action_description &&
          this.uploadData[i].action_description !== "skip" &&
          this.uploadData[i].action_description !== "overwrite"
        ) {
          validate = false;
          break;
        }
      }
      if (validate === true) {
        this.statusUpload = "confirm";
        clearInterval(this.setInterval);
      }
    },
    async confirm() {
      this.dialogLoader = true;
      // if (this.formatType === 'master') {
      if (this.statusOldUpload === "duplicate Invoice No in excel file") {
        this.statusOldUpload = "no duplicate Invoice No in excel file";
      } else if (
        this.statusOldUpload === "duplicate Invoice No" ||
        this.statusOldUpload === "wait confirm"
      ) {
        this.statusOldUpload = "confirm";
      }
      // }
      var { data: company_data } = await this.axios.post(
        process.env.VUE_APP_APIHOST + "/check_file_invoice",
        {
          username: this.userName,
          data: this.uploadData,
          status: this.statusOldUpload,
          formattype: this.formatType
        },
        { headers: { Authorization: this.$cookies.get("token") } }
      );
      // console.log('check_file_company: ', company_data)
      this.dialogLoader = false;
      this.statusUpload = company_data.status;
      this.statusOldUpload = company_data.status;
      if (company_data.status === "success") {
        this.showReview = false;
        Swal.fire({
          title: "Upload Successful",
          text: "",
          icon: "success"
        }).then(function() {
          location.reload();
        });
      } else {
        this.uploadData = company_data.data;
        this.setInterval = setInterval(() => this.checkUploadFile(), 5000);
      }
    },
    async uploadFile() {
      if (this.$refs.formExcel.validate()) {
        if (this.isFile && this.sheetName) {
          this.dialogLoader = true;
          var data = new FormData();
          // data.append('username', this.userName)
          data.append("sheetname", this.sheetName);
          data.append("file", this.$refs.fileExcel.files[0]);
          var { data: upload_data } = await this.axios.post(
            `${process.env.VUE_APP_APIHOST}/upload_file_invoice`,
            data
          );
          // console.log('upload_file_invoice: ', upload_data)
          this.dialogLoader = false;
          if (upload_data.status == "Success") {
            this.$swal("Upload Successful", "", "success");
            location.reload();
            // this.isFile = false
            // this.fileName = ''
            // this.$refs.formExcel.reset()
          } else {
            this.$swal("Upload Failed", upload_data.status, "error");
          }
          // this.statusUpload = upload_data.status
          // this.statusOldUpload = upload_data.status
          // if (upload_data.status === 'wait confirm') {
          //   this.showReview = true
          //   this.uploadData = upload_data.data
          //   this.formatType = upload_data.format_type
          //   clearInterval(this.setInterval)
          // } else if (upload_data.status === 'Incomplete format' || upload_data.status === 'Sheet name not found') {
          //   this.$swal('Upload Failed', upload_data.status, 'error')
          // } else {
          //   this.showReview = true
          //   this.uploadData = upload_data.data
          //   this.formatType = upload_data.format_type
          //   this.setInterval = setInterval(() => this.checkUploadFile(), 5000)
          // }
        } else if (!this.isFile && this.sheetName) {
          this.$swal("Upload Failed", "Choose File", "error");
        }
      }
    },
    handleView() {
      this.mobileView = window.innerWidth <= 990;
    }
  },
  created() {
    // console.log('crated token: ', this.$cookies.get('token'))
    this.handleView();
    window.addEventListener("resize", this.handleView);
  }
};
</script>

<style>
table {
  width: 10%;
}
.mytable table th {
  border-bottom: none;
  font-weight: bolder;
}
.v-text-field input {
  font-size: 0.9em;
}
.v-input__slot {
  min-height: 26px !important;
}
.v-input__icon--prepend .v-icon {
  color: black;
}
</style>
